<script setup lang="ts">
interface Props {
  value: string
  minRows: number
  maxRows: number
}

// make input scale with no of lines
const {
  value = '',
  minRows,
  maxRows,
} = defineProps<Props>()
const emit = defineEmits(['input'])

const minHeight = computed(() => `${1 + minRows * 1.2}em`)
const maxHeight = computed(() => (maxRows ? `${1 + maxRows * 1.2}em` : 'auto'))
</script>

<template>
  <div class="relative border border-black m-2 text-lg w-3/5">
    <pre aria-hidden="true" :style="{ minHeight, maxHeight }" class="overflow-hidden">{{ `${value}\n` }}</pre>
    <textarea
      class="absolute w-full h-full top-0 resize-none scrollBar overflow-auto dark:bg-neutral-700"
      name=""
      cols="30"
      rows="10"
      :value="value"
      v-bind="$attrs"
      @input="emit('input', $event.target.value)"
    />
  </div>
</template>

<style scoped>
pre,
textarea {
  font-family: inherit;
  padding: 0.5em;
  box-sizing: border-box;
  border: 1px solid #eee;
  line-height: 1.2;
  width: 100%;
  border-radius: 5px;
}
</style>
